///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
 *	OPCODE - Optimized Collision Detection
 *	Copyright (C) 2001 Pierre Terdiman
 *	Homepage: http://www.codercorner.com/Opcode.htm
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains code for box pruning.
 *	\file		IceBoxPruning.h
 *	\author		Pierre Terdiman
 *	\date		January, 29, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 * Updated by Stephen G. Tuggy 2021-07-03
 * Updated by Stephen G. Tuggy 2022-01-06
 * Updated by Benjamen R. Meyer 2023-05-27
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef VEGA_STRIKE_ENGINE_CMD_COLLSION2_OPC_BOXPRUNING_H
#define VEGA_STRIKE_ENGINE_CMD_COLLSION2_OPC_BOXPRUNING_H

// Optimized versions
FUNCTION OPCODE_API bool CompleteBoxPruning(uint32_t nb, const AABB **array, Pairs &pairs, const Axes &axes);
FUNCTION OPCODE_API bool BipartiteBoxPruning(uint32_t nb0,
        const AABB **array0,
        uint32_t nb1,
        const AABB **array1,
        Pairs &pairs,
        const Axes &axes);

// Brute-force versions
FUNCTION OPCODE_API bool BruteForceCompleteBoxTest(uint32_t nb, const AABB **array, Pairs &pairs);
FUNCTION OPCODE_API bool BruteForceBipartiteBoxTest(uint32_t nb0,
        const AABB **array0,
        uint32_t nb1,
        const AABB **array1,
        Pairs &pairs);

#endif //VEGA_STRIKE_ENGINE_CMD_COLLSION2_OPC_BOXPRUNING_H
